//
//  ViewController.m
//  UserHeaderDemo
//
//  Created by job on 16/8/24.
//  Copyright © 2016年 job. All rights reserved.
//

#import "ViewController.h"
#import "UIImage+ImageEffects.h"
#import "JKImagePickerController.h"

//获取屏幕设度，高度
#define kScreenHight [UIScreen mainScreen].bounds.size.height
#define kScreenWidth [UIScreen mainScreen].bounds.size.width
#define headViewH    kScreenWidth/3*2
#define headH        kScreenWidth/4

@interface ViewController ()<UITableViewDelegate,UITableViewDataSource,JKImagePickerControllerDelegate>
@property (strong, nonatomic) UITableView *table;
@property (strong, nonatomic ) NSArray *listArray;
@property (nonatomic,strong) UIImageView *bgImageView;
@property (nonatomic,strong) UIImageView *headerImageView;
@property (nonatomic,assign)CGFloat scale;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
     _listArray =  @[@"简  历",@"隐  私",@"收  藏",@"投递记录",@"设  置"];
    
    [self.view addSubview:self.table];
    [self initView];
}


-(void)initView {
    self.table.contentInset = UIEdgeInsetsMake(headViewH, 0, 0, 0);
    _bgImageView = [[UIImageView alloc]initWithFrame:CGRectMake(0, -headViewH, kScreenWidth, headViewH)];
    _bgImageView.layer.masksToBounds = YES;
    _bgImageView.userInteractionEnabled = YES;
    _bgImageView.image = [[UIImage imageNamed:@"123.jpg"] blurImage];
    _headerImageView = [[UIImageView alloc]initWithFrame:CGRectMake(0, 0, headH, headH)];
     self.scale = _bgImageView.bounds.size.width/_bgImageView.bounds.size.height;
    _headerImageView.center = _bgImageView.center;
    _headerImageView.layer.masksToBounds = YES;
    _headerImageView.userInteractionEnabled = YES;
    _headerImageView.image = [UIImage imageNamed:@"123.jpg"];
    _headerImageView.layer.cornerRadius = headH/2;
    UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(headerClick)];
    [_headerImageView addGestureRecognizer:tap];
    _headerImageView.userInteractionEnabled = YES;
     [self.table addSubview:_bgImageView];
    [self.table addSubview:_headerImageView];
    
   
}

-(UITableView *)table {
    if (!_table) {
        _table = [[UITableView alloc]initWithFrame:CGRectMake(0, 0, self.view.bounds.size.width, self.view.bounds.size.height) style:UITableViewStylePlain];
        _table.delegate = self;
        _table.dataSource = self;
        
    }
    return _table;
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return _listArray.count;
}
-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *identifier = @"cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:identifier];
    if (!cell) {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:identifier];
    }
    cell.textLabel.text = _listArray[indexPath.row];
    return cell;
}

- (void)scrollViewDidScroll:(UIScrollView *)scrollView {
    CGFloat offsetY = scrollView.contentOffset.y;
    
    if (scrollView.contentOffset.y < -headViewH ) {
        // 高度宽度同时拉伸 从中心放大
        self.bgImageView.frame = CGRectMake(0, offsetY, kScreenWidth, -offsetY);
        CGFloat conY = scrollView.contentOffset.y  +headViewH;
        NSLog(@"conY--%f",conY);
        NSLog(@"scale--%f",self.scale);
        
        CGFloat imgH = -(offsetY);
        CGFloat imgW = imgH * self.scale;
        self.bgImageView.frame = CGRectMake(-(imgW - kScreenWidth)/2,offsetY, imgW,imgH);
        
 
      
        self.headerImageView.frame =CGRectMake(0, 0, headH-conY, headH-conY);
          self.headerImageView.center =self.bgImageView.center;
         _headerImageView.layer.cornerRadius = _headerImageView.bounds.size.height/2;
 
    }
    NSLog(@"%0.0f",scrollView.contentOffset.y);
}

-(void)headerClick {
    JKImagePickerController *imagePickerController = [[JKImagePickerController alloc] init];
    imagePickerController.delegate = self;
    imagePickerController.showsCancelButton = YES;
    imagePickerController.isChooseHeader = YES;
    imagePickerController.allowsMultipleSelection = YES;
    //        imagePickerController.minimumNumberOfSelection = 1;
    //        imagePickerController.maximumNumberOfSelection = 9;
    UINavigationController *navigationController = [[UINavigationController alloc]initWithRootViewController:imagePickerController];
    
    
    [self presentViewController:navigationController animated:YES completion:NULL];
}
- (void)imagePickerControllerDidCancel:(JKImagePickerController *)imagePicker
{
    [imagePicker dismissViewControllerAnimated:YES completion:^{
        
    }];
}


-(void)imagePickerController:(JKImagePickerController *)imagePicker didSelectAsset:(JKAssets *)asset isSource:(BOOL)source {
    
}

- (void)imagePickerController:(JKImagePickerController *)imagePicker didSelectAssets:(NSArray *)assets isSource:(BOOL)source{
    
    __weak typeof(self) weakSelf = self;
    [imagePicker.navigationController dismissViewControllerAnimated:YES completion:^{
        
        
    }];
    
    
}


-(void)cutViewCommpelteChooseImage:(UIImage *)image viewCon:(CutImageViewController *)viewCon {
    __weak typeof(self) weakSelf = self;
    [viewCon.navigationController dismissViewControllerAnimated:YES completion:^{
        _bgImageView.image = [image blurImage];
        _headerImageView.image = image;
        
    }];
}




- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
